/*
actionURL() - An Enhanced openURL() for Yahoo! Widgets  - 20071110
Copyright  2006-2007 G6AUC

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// 17 July 2007 with mailto change
// 11 November 2007 with Flip4Mac WMV Player additions

		var Referer = "";

		function xtn(s)
		{
			var ext;
			var idx = s.lastIndexOf(".");
			if (idx >= 0 )
			{
				ext = s.substring(idx);
				if (ext.length > 7) { return ""; }
				if (ext.length > 1) { return ext; }
			}
			return "";
		}

		function theURL(url, outputFile, referer)
		{
			var i;
			var myUrl = new URL();
			if (outputFile !== "") { myUrl.outputFile = outputFile; }
			if (referer    !== "") { myUrl.setRequestHeader( "Referer", referer ); }
			var result = myUrl.fetch(url);
			var resp = myUrl.response;
			print('theURL:resp=' + resp);
			
			var dates = myUrl.getResponseHeaders('*');
			if (dates !== null)
			{
				print('=== ResponseHeaders ===');
				for (i = 0; i < dates.length; i += 1)
				{
					if (dates[i] !== undefined) { print(dates[i]); } 
				}
				print('=== =============== ===');
			}

			if (outputFile !== "") { print('theURL:result=' + result); }
			var OK = ((resp == 200) || (resp === 0));	// resp === 0 for local files
			if (outputFile !== "")
			{
				if (OK) { return ""; } else { return 'Cannot fetch "' + url + '". HTTP Error code ' + resp + '.'; }
			}
			else
			{
				if (OK) { return result; } else { return ""; }
			}
		}

		function actionURL(url)
		{
			print("---------------------- actionURL -------------------------");
			print("url:      " + url);

			var fullurl   = "";
			var protocol  = "";
			var host      = "";
			var filePath  = "";
			var getParams = "";
			var fragment  = "";
			var site      = "";
			
			var fileName, idx, newUrl, extn, path, returnValue;
			
			var URL = /^(([^:\/\?\#]+):)?(\/\/([^\/\?\#]*))?([^\?\#]*)(\?([^\#]*))?(#(.*))?/;		// from RFC 3986

			var result = url.match(URL);
			if (result !== null)
			{
				fullurl  = result[0];									print("fullurl:  " + fullurl);
				protocol = result[2];
				host     = result[4];
				filePath = result[5];				
				getParams= result[7];
				fragment = result[9];
				
				if (protocol === undefined)
				{
					if (host === undefined) { protocol = "file"; } 		else { protocol = "http"; }
				}
																		print("protocol: " + protocol);
				if (host === undefined) { host = ""; }					print("host:     " + host);
				if (filePath === undefined) { filePath = ""; }			print("filePath: " + filePath);
				if (getParams === undefined) { getParams = "";	}		print("getParms: " + getParams);
				if (fragment === undefined) { fragment = ""; }			print("fragment: " + fragment);

				//site = protocol + "://" + host;
				site = protocol + ":";

				if (protocol != "mailto") { site += "//" + host; }		print("site:     " + site);

				fileName = filePath;
  				idx = filePath.lastIndexOf("/");
   				if (idx >= 0) { fileName = filePath.substring(idx + 1); }
   				if (fileName === "") { fileName = 'index.html'; }
																		print("fileName: " + fileName);
				newUrl = site + filePath;
				extn = xtn(newUrl);
				
				if (getParams !== "") { newUrl += "?" + getParams; }
														
				if (fragment !== "")  {	newUrl += "#" + fragment; }		print("newUrl:   " + newUrl);								

				print('Fetching url: ' + newUrl);
				
				if ((systemPlatform == 'macintosh') && filesystem.itemExists("/Applications/Flip4Mac/WMV Player.app") && (preferences.wmvPlayerPref.value == "1"))
				{
					if ((protocol == "mms")  || (extn == ".mp4") || (extn == ".avi") || (extn == ".mov") || (extn == ".qtl") || (extn == ".mp3") ||
						(extn     == ".asf") || (extn == ".wmv") || (extn == ".wm" ) || (extn == ".wpl") || (extn == ".wma")) {
						playWMPstream(newUrl, 100, false, false);
						return;
					}
				}
				
				if (protocol != "http") { print('Using openURL: ' + openURL(newUrl)); return ""; }
				
  				if ((extn == '.qtl') || (extn == '.asx') || (extn == '.wax') || (extn == '.wvx') || (extn == '.wpl'))
  				{
   					path = system.widgetDataFolder + "/" + fileName;	// read metafile
   					returnValue = theURL(newUrl, path, Referer);
  					Referer = newUrl;
  					if (returnValue !== "") { return returnValue; }
   					print('=== Content of Metafile ===');
  					print(filesystem.readFile(path));
   					print('=== =================== ===');
   					filesystem.open(path);	// open metafile
  				}
  				else { print('Using openURL: ' + openURL(newUrl)); return ""; }
  			}
  			else
  			{
  				returnValue = "Not a valid url.";
  			}
			print("-------------------end of actionURL ----------------------");
  			return returnValue;
		}
